=== modified file 'configure.ac'
--- configure.ac	2008-11-26 07:43:57 +0000
+++ configure.ac	2008-11-26 08:51:53 +0000
@@ -630,16 +630,25 @@
 SEARCH_FOR_LIB(z, crc32, zlib.h, 
                AC_MSG_ERROR([libz is required for Drizzle]))
 
+#--------------------------------------------------------------------
+# Check for libncurses
+#--------------------------------------------------------------------
+
+
+SEARCH_FOR_LIB(ncurses, tgetent, ncurses/ncurses.h, AC_MSG_ERROR(Couldn't find ncurses)) 
 
 #--------------------------------------------------------------------
 # Check for libreadline or compatible (libedit on Mac OS X)
 #--------------------------------------------------------------------
 
-AC_CHECK_HEADERS(readline/history.h readline/readline.h)
-if test "x$ac_cv_header_readline_readline_h" != "xyes"
-then
-  AC_MSG_ERROR([Couldn't find readline/readline.h. Try installing readline development packages.])
-fi
+
+SEARCH_FOR_LIB(readline, rl_initialize, readline/readline.h,
+               AC_MSG_ERROR([libreadline is required for Drizzle]),
+               [$NCURSES_LIBS]) 
+
+save_CPPFLAGS="$CPPFLAGS"
+CPPFLAGS="$CPPFLAGS $READLINE_CPPFLAGS"
+AC_CHECK_HEADERS(readline/history.h)
 AC_CHECK_TYPES([HIST_ENTRY], [], [], [AC_INCLUDES_DEFAULT[
 #ifdef HAVE_READLINE_HISTORY_H
 #include <readline/history.h>
@@ -654,16 +663,7 @@
 ]])
 
 DRIZZLE_CHECK_NEW_RL_INTERFACE
-
-my_save_LIBS="$LIBS"
-LIBS=""
-AC_CHECK_LIB(readline, rl_initialize, [],
-  [AC_CHECK_LIB(ncurses, tgetent, [], [AC_MSG_ERROR(Couldn't find ncurses)]) 
-   AC_SEARCH_LIBS(rl_initialize, readline, [],
-    [AC_MSG_ERROR(Couldn't find libreadline.)])])
-READLINE_LIBS="$LIBS"
-LIBS="$my_save_LIBS"
-AC_SUBST(READLINE_LIBS)
+CPPFLAGS="$save_CPPFLAGS"
 
 
 #--------------------------------------------------------------------

=== modified file 'm4/search_for_lib.m4'
--- m4/search_for_lib.m4	2008-11-25 00:40:13 +0000
+++ m4/search_for_lib.m4	2008-11-26 08:51:53 +0000
@@ -1,5 +1,6 @@
 dnl SEARCH_FOR_LIB(LIB, FUNCTIONS, FUNCTION,
-dnl                [ACTION-IF-NOT-FOUND])
+dnl                [ACTION-IF-NOT-FOUND],
+dnl                [LIBS_TO_ADD])
 
 AC_DEFUN([SEARCH_FOR_LIB],
 [
@@ -22,7 +23,7 @@
     AC_CHECK_HEADERS([$3])
 
     my_save_LIBS="$LIBS"
-    LIBS=""
+    LIBS="$5"
     AC_CHECK_LIB($1, $2)
     AS_VAR_SET([libs_var],[${LIBS}])
     LIBS="${my_save_LIBS}"
@@ -34,9 +35,9 @@
       ])
   ])
   AS_IF([test "AS_VAR_GET([with_lib])" != yes],[
-   AC_MSG_CHECKING(for $1 in $withval)
    for libloc in AS_VAR_GET([with_lib])
    do
+    AC_MSG_CHECKING(for $1 in $libloc)
     if test -f $libloc/$3 -a -f $libloc/lib$1.a
     then
       owd=`pwd`

